package bintools

import net.sergeych.bintools.Varint
import net.sergeych.bintools.decode
import net.sergeych.bintools.encode
import net.sergeych.bintools.encodeToHex
import kotlin.test.Test
import kotlin.test.assertEquals

class VarintTest {

    inline fun <reified T: Any>testValue(x: T) {
        assertEquals(x, Varint.decode(Varint.encode(x)))
//        assertEquals(x, Varint.decodeSigned(Varint.encodeSigned(x)))
        println("+ ${x}: ${Varint.encode(x).encodeToHex()}")
    }

    fun testAround(bits: Int) {
        val window = 5
        var median: Long = (1.toULong() shl bits).toLong()
        for( x in (median-5)..(median+5)) {
            testValue(x)
            testValue(-x)
        }
        median = median * 3 / 2
        for( x in (median-5)..(median+5)) {
            testValue(x)
            testValue(-x)
        }
    }

    @Test
    fun encode() {
//        for( i in 0..300) testValue(i.toLong())
        testAround(7)
        testAround(7)
        testAround(14)
        testAround(21)
        testAround(28)
    }

    @Test
    fun negative() {
        testValue(-1)
        testValue(-2)
        testValue(-3)
    }
}